#include <Windows.h>
#include <stdio.h>
#include <tchar.h>
#include <wincrypt.h>

union HASH_UINT128{
	UINT64	u64[2];
	UINT32	u32[4];
	BYTE	u8[16];

	void hex(char* s){
		sprintf_s(s, 33, "%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x%0.2x", u8[0], u8[1], u8[2], u8[3], u8[4], u8[5], u8[6], u8[7], u8[8], u8[9], u8[10], u8[11], u8[12], u8[13], u8[14], u8[15]);
	}
};


bool md5Hashed(char* key, DWORD dwLength, HASH_UINT128* u128){
	HCRYPTPROV hProv = 0;
	HCRYPTHASH hHash = 0;
	if (!CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT)){
		MessageBox(0, _TEXT("CryptAcquireContext"), _TEXT("Error"), MB_OK);
		return false;
	}
	if (!CryptCreateHash(hProv, CALG_MD5, 0, 0, &hHash)){
		MessageBox(0, _TEXT("CryptCreateHash"), _TEXT("Error"), MB_OK);
		CryptReleaseContext(hProv, 0);
		return false;
	}
	if (!CryptHashData(hHash, (BYTE*)key, dwLength, 0)){
		MessageBox(0, _TEXT("CryptCreateHash"), _TEXT("Error"), MB_OK);
		CryptDestroyHash(hHash);
		CryptReleaseContext(hProv, 0);
		return false;
	}
	DWORD dwRead = 16;
	if (!CryptGetHashParam(hHash, HP_HASHVAL, (BYTE*)u128, &dwRead, 0)){
		MessageBox(0, _TEXT("CryptGetHashParam"), _TEXT("Error"), MB_OK);
		CryptDestroyHash(hHash);
		CryptReleaseContext(hProv, 0);
		return false;
	}
	CryptDestroyHash(hHash);
	CryptReleaseContext(hProv, 0);
	return true;
}


void hmac_md5(char* key,char* data,HASH_UINT128* dtc){
	int n;
	char temp[64+16];

	int len = (int)strlen(key);
	strcpy_s(temp, sizeof(temp), key);
	SecureZeroMemory(temp+len, 64-len);

	for (n = 0; n < 64; n++)
		temp[n] = temp[n] ^ 0x36;
	strcpy_s(temp+64, sizeof(temp)-64,data);

	md5Hashed(temp, 64+(int)strlen(data), dtc);
	strcpy_s(temp, sizeof(temp), key);
	SecureZeroMemory(temp + len, 64 - len);

	for (n = 0; n < 64; n++)
		temp[n] = temp[n] ^ 0x5c;

	memcpy(temp + 64, dtc, 16);

	md5Hashed(temp, 64+16, dtc);
}

void main(void){
	char* key = "pass";
	char* data = "hello";

	HASH_UINT128 hash;
	char hexs[34];

	hmac_md5(key, data, &hash);
	hash.hex(hexs);
	printf("HMAC MD5 %s\n", hexs);
}